// SviUsbControl.h: CSviUsbControl NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SVIUSBCONTROL_H__19B3D7F6_CEA6_4B17_9A40_CAD728E223C3__INCLUDED_)
#define AFX_SVIUSBCONTROL_H__19B3D7F6_CEA6_4B17_9A40_CAD728E223C3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <vector>
#include "SviStatus.h"
#include "SVIUSB20.h"

using namespace std;

//SVIUSB2.0hCoɑ΂鑀bv܂B
class CSviUsbControl
{
public:
	bool close();
	void SetSelBoardNo(int no);
	ULONG ulSelBoardNo;
	ULONG GetDeviceID(int no);
	ULONG GetBoardNum();
	DWORD ScanBoard();
	ULONG ulBoardNum;
	ULONG ulBoardInfo[4];
	//RXgN^
	CSviUsbControl();

	virtual ~CSviUsbControl();

	//SVIn[hEFA܂
	bool DeviceReset(void);

	//SVIhCoI[v܂
	bool open(void);

	//SVIXe[^XXV܂(onlyBaseStatus : {Xe[^X̂ݍXVj
	bool refreshStatus(bool onlyBaseStatus = false);

	//SVIXe[^X擾܂
	CSviStatus* getStatus(void){return &SviStatus;};

	//G[R[h擾܂BiG[R[h͏܂B)
	DWORD getLastError(void);

	//G[R[h𕶎ɕϊ܂B
	CString getLastErrorString(DWORD errorcode);

	//JWX^̐ݒ(TuAhXwL)
	bool SetValue(ULONG ulSlaveAdr,ULONG ulSubAdr,PUCHAR pRcvBuff,ULONG ulLen, BOOL bWord);
	// I[vN[Y͊Oōsꍇ
	bool SetValue2(ULONG ulSlaveAdr,ULONG ulSubAdr,PUCHAR pRcvBuff,ULONG ulLen, BOOL bWord);

	//JWX^̐ݒ(TuAhXwAobt@Ɋi[) 2006.1.13 update
	bool SetValue(ULONG ulSlaveAdr,PUSHORT pRcvBuff,ULONG ulLen);

	//JWX^̎擾
#if 1 // 2012.07.24 V3.2.2.0
	bool GetValue(ULONG ulSlaveAdr,ULONG ulSubAdr,PUCHAR pRcvBuff,ULONG ulLen, BOOL bWord, BOOL bRestart);
#else
	bool GetValue(ULONG ulSlaveAdr,ULONG ulSubAdr,PUCHAR pRcvBuff,ULONG ulLen, BOOL bWord);
#endif // 2012.07.24 V3.2.2.0

private:
	bool I2CBlockRead(ULONG ulSlaveAdr, ULONG ulLen, ULONG ulReadMode, PUCHAR pucRcvBuf);
	//G[`FbNPiprivate)
	bool CSviUsbControl::checkLastError(void);

	//^[R[h
	DWORD RC;

	//SVIn[hEGAXe[^X
	CSviStatus SviStatus;

	// PoCgM

	// PoCgM

	// X^[gRfBV

	// XgbvRfBV
	bool I2CStop();

	// PubNM
	bool I2CBlockWrite(ULONG	ulSlaveAdr,	ULONG	ulLen,	ULONG	ulWriteMode,	PUCHAR	pucSendBuf);
};

#endif // !defined(AFX_SVIUSBCONTROL_H__19B3D7F6_CEA6_4B17_9A40_CAD728E223C3__INCLUDED_)
